-- Upgrade pre-check
CHECK_DEVICE_TYPE = "G1"
CHECK_OEM_TYPE = "G1"
CHECK_VERSION_MATCH = true
VERSION_MATCH_ONLY = nil
VERSION_MATCH_LT = "4.5.2300"
VERSION_MATCH_GT = "0"
NEW_VERSION="4.5.2300"
---- Up before this are arguments auto generated by upgrading scripts ---
local function UpgradePreCheck( tmpLoc )
	if CHECK_DEVICE_TYPE or CHECK_OEM_TYPE then
		local done, _r = pcall(require,"oem")
		if not done then
			return false, "device-type-error"
		end
		if CHECK_DEVICE_TYPE and CHECK_DEVICE_TYPE ~= _G.DEVICE_TYPE then
			return false, "device-type-error"
		end
		if CHECK_OEM_TYPE and CHECK_OEM_TYPE ~= _G.OEM_TYPE then
			return false, "device-type-error"
		end
	end

	if CHECK_VERSION_MATCH then
		local done, _r = pcall(require,"version")
		if not done or not SOFTWARE_VERSION then
			return false, "device-type-error"
		end
		if VERSION_MATCH_ONLY then
			if SOFTWARE_VERSION ~= VERSION_MATCH_ONLY and SOFTWARE_VERSION ~= NEW_VERSION then
				return false, "version-wrong"
			end
		--Only matched numeric '.????' suffix.
		elseif SOFTWARE_VERSION:match("%.%d?%d?%d?%d?$") then
			if SOFTWARE_VERSION < VERSION_MATCH_GT then
				return false, "bin-base-version-is-higher"
			elseif SOFTWARE_VERSION > VERSION_MATCH_LT then
				return false, "bin-version-is-old"
			end
		end
	end

	return true, "done"
end

return UpgradePreCheck

